package ru.dbotthepony.mc.otm.client.screen.panels.button

import com.mojang.blaze3d.platform.InputConstants
import com.mojang.blaze3d.vertex.PoseStack
import net.minecraft.client.gui.screens.Screen
import ru.dbotthepony.mc.otm.client.render.AbstractMatterySprite
import ru.dbotthepony.mc.otm.client.screen.panels.EditablePanel
import ru.dbotthepony.mc.otm.core.GetterSetter
import ru.dbotthepony.mc.otm.core.value

abstract class BooleanRectangleButtonPanel<out S : Screen>(
	screen: S,
	parent: EditablePanel<*>?,
	x: Float = 0f,
	y: Float = 0f,
	width: Float,
	height: Float,
	val prop: GetterSetter<Boolean>,
	val skinElementActive: AbstractMatterySprite? = null,
	val skinElementInactive: AbstractMatterySprite? = null,
	val onChange: ((newValue: Boolean) -> Unit)? = null,
) : RectangleButtonPanel<S>(screen, parent, x, y, width, height, null) {
	override fun onClick(mouseButton: Int) {
		val newValue = !prop.value
		prop.value = newValue
		onChange?.invoke(newValue)
	}

	override fun innerRender(stack: PoseStack, mouseX: Float, mouseY: Float, partialTick: Float) {
		super.innerRender(stack, mouseX, mouseY, partialTick)

		if (prop.value) {
			skinElementActive?.render(stack, width = width, height = height)
		} else {
			skinElementInactive?.render(stack, width = width, height = height)
		}
	}
}
